package sub_arctic.anim;
import sub_arctic.input.event;
/**
 * This interface defines how the timer callback works. This can be
 * used in any part of a sub_arctic application or applet to get 
 * notification that some amount of time has elapsed. The amount
 * of time to wait should be specified by creating a timer
 * transition and scheduling it with the animation agent.<p>
 * 
 * @see timer_transition
 * @author Ian Smith
 */
public interface timer {
  /**
   * This method is called when the amount of time requested via
   * the timer_transition has elapsed.
   * @param event e the event that caused the timer to expire. This is
   *                animation event, and can safely be ignored by most
   *                users of this interface.
   */
  public void time_expired(event e);
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
