package sub_arctic.lib;

/** 
 * An object which can be given to manager.handle_unexpected_exception() to
 * perform a custom action when an unexpected exception is caught.
 * @see sub_arctic.lib.manager
 * @author Scott Hudson
 */
public interface exception_handler {
  /** Do something in response to an exception.  Note that we don't allow
   *  this to throw a different exception (but it could throw an error).  
   *
   * @param Exception ex the unexpected exception that has been caught.
   */
  public void handle_exception(Exception ex);
}

/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
