package sub_arctic.anim;

/** 
 * This is an interface for implementing pacing functions.<P>
 *
 * Your function should map a point in a time interval (0.0 to 1.0)
 * to another point in that interval.<p>
 *
 * @author Ian Smith
 */
public abstract interface pacer {
/**
 * This is the function which does the work of the mapping.<p>
 *
 * @param double f the input time value (0.0 to 1.0)
 * @return double the transformed time value
 */
  public double pace(double f);
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
