
package sub_arctic.input;

/** 
 * Simple object to encapsulate an integer. This class is used simulate 
 * full pass-by-reference when needed (i.e., to allow integer parameters 
 * to be modified and returned by a method).
 *
 * @author Scott Hudson
 */
public class int_holder
  {
    /** The value we encapsulate. */
    public int value = 0;

    /** Constructor with explicit initialization. */
    public int_holder(int v) { value = v; }

    /** Constructor that initializes to 0. */
    public int_holder() { value = 0; }
  }
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
