package sub_arctic.input;

/**
 * This is a little holder for two objects. It used by the manager
 * and the work_agent to communicate two objects (the work to do
 * and its argument).
 *
 * @author Ian Smith
 */

public class work_pair {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** The work to do.  */
  protected work_proc _proc;

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /**
   * Retrieve the work proc from this pair.
   * @return work_proc the work proc object
   */
  public work_proc proc() { return _proc;}

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** The object to pass to the work proc when it runs.  */
  protected Object _obj;

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /**
   * Retrieve the object to be passed to the work proc when it runs.
   * @return Object the object which is to be the work proc's parameter.
   */
  public Object obj() { return _obj;}

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /**
   * Create a work pair.
   * @param work_proc proc the procedure to call.
   * @param Object obj the work proc's parameter.
   */
  public work_pair(work_proc proc, Object obj) {
    _obj=obj;
    _proc=proc;
  }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
