
package sub_arctic.lib;

import sub_arctic.input.*;
import sub_arctic.output.*;
import sub_arctic.constraints.constraint;

/**
 * This class is here to help the panner know when its children's size
 * gets changed. This lets it recompute the values for its scrollbars
 * and what not.
 *
 * @author Ian Smith
 */
class panner_helper extends base_parent_interactor {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Default constructor.
   */
  panner_helper()  {
    super(0,0);
    setup_for_fixed_children(1);
  }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * This gets called when our size changes. We use it to echo information
   * back to the panner.
   * @param int v new w value
   * @exception general
   */
  protected void set_raw_w(int v)  {
    panner p;

    /* call the super's code to keep things working */
    super.set_raw_w(v);

    p=(panner)(parent().parent());
    p.child_size_changed_w(v);
  }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * This gets called when our size changes.  We use it to echo information
   * back to the panner.
   * @param int v new h value
   */
  protected void set_raw_h(int v)  {
    panner p;

    /* call the super's code to keep things working */
    super.set_raw_h(v);

    p=(panner)(parent().parent());
    p.child_size_changed_h(v);
  }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
